\ ipp-stack.fs
\ 
] here \ Target Forth, start marker

\ 
0 [if] \ ------------------[ ipp stack operations ]---------------------------
\ 
\ 1. Host words to perform/observe stack operations on the ipp
\ 2. @ps gets a byte from the ipp and puts it on the Host stack
\ 3. !ps writes a byte on the Host to the ipp.
\ 4. psd gets the depth of the ipp stack
\ 5. .ps  displays the contents of the ipp stack on the Host
\ 
[then] \ ----------------------------------------------------------------------
\ 
[ \ Gforth
\ 
: (ps)  [char] p emit-s  [char] s emit-s ;

: !ps  ( n --)  \ put number on IPP stack (put stack)
   depth 0= abort" no number on stack!"  
   [char] ! emit-s  (ps) isend  h.-s ; 

: psd  ( n --)  (ps) [char] d emit-s isend= ;  \ get IPP stack depth

: @ps  ( -- n)  \ get byte from IPP stack
   psd if [char] @ emit-s (ps) isend= else ." empty" then ;

\ displays IPP stack in hex
: .ps  [char] . emit-s  (ps) isend= 
   ?dup 0= if ." empty" else dup h.$ ." > " 0 do key-s h.$ loop then ;
\ 
] \ myforth
\ 
: !ps  $  ;
: psd  depth (emit) ;
: .ps  psd  .sraw ;
: @ps  (emit) ;
\ 
here ( stop marker) [ swap -  ( -- n)
cs? [if] cr .( ipp-stack.fs        ) . .( bytes) [else] drop [then]
]

